Add a note about where to find makexml
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.2
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset drc="0.0"
48 typeset -i default_aid=128
49 typeset -i aid_override=-1
50 typeset -i force_onepass_mode=0
51 typeset -i eject_disk=1
52 typeset -i keep_isofile=0
53 typeset -i keep_vobfile=0
54 typeset -i keep_dvdfolder=0
55 typeset -i keep_intermediate_files=0
56 typeset -i make_final_dest_vob=0
57 typeset -i make_final_dest_iso=0
58 typeset -i make_final_dest_folder=0
59 typeset -i make_final_dest_comp=0
60 typeset -i errors=0
61 typeset -i show_usage=0
62 typeset -i mirror_mode=0
63 typeset -i target_bitrate=2000
64 typeset -i target_size=0
65 typeset -i audio_2ch=0
66 typeset -i audio_6ch=1
67 typeset -i invalid_feature_title=0
68 typeset -i feature_title_override=0
69 typeset -i mplayer_dumpstream_incompatibility=0
70 typeset -i custom_bitrate=0
71 typeset -i custom_audio_2ch=0
72 typeset -i custom_audio_6ch=0
73
74 ##############################################################################
75 # Local Machine Settings:
76 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
77 # and the local conf file created by each local machine (rip_dvd.conf)
78 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
79 # This will allow you to override all the default values to meet your needs
80 # in a way that won't get clobbered when you pull updates from my GIT repo.
81 ##############################################################################
82 config="${0%/*}/rip_dvd.conf"
83
84 # The config file will be searched for in the following location order:
85 found_config=0
86
87 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
88 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
89
90 # 2) /path/to/rip_dvd/script/rip_dvd.conf
91 [ -e "${config}" ] && found_config=1 && . "${config}"
92
93 # 3) /etc/rip_dvd.conf
94 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
95
96 # 4) $PWD/rip_dvd.conf
97 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
98
99 # Check to make sure we found the config file
100 if [ $found_config -eq 0 ]; then
101   echo "-E- Unable to find the rip_dvd.conf file: $config"
102   exit 1
103 fi
104
105 ##############################################################################################
106 # Command line processing
107 ##############################################################################################
108 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
109 do
110     case $opt in
111         (n)     dvdname=$OPTARG;;
112         (d)     dest=$OPTARG;;
113         (b)     target_bitrate=$OPTARG; custom_bitrate=1;;
114         (s)     target_size=$OPTARG;;
115         (2)     audio_2ch=1; custom_audio_2ch=1;;
116         (6)     audio_6ch=1; custom_audio_6ch=1;;
117         (1)     force_onepass_mode=1;;
118         (v)     make_final_dest_vob=1;;
119         (i)     make_final_dest_iso=1;;
120         (f)     make_final_dest_folder=1;; 
121         (z)     make_final_dest_comp=1;;
122         (e)     encoder=$OPTARG;;
123         (m)     mirror_mode=1;;
124         (k)     keep_intermediate_files=1;;
125         (t)     feature_title_override=$OPTARG;;
126         (a)     aspect=$OPTARG;;
127         (p)     profile=$OPTARG;;
128         (x)     extension=$OPTARG;;
129         (j)     eject_disk=$OPTARG;;
130         (l)     aid_override=$OPTARG;;
131         (r)     drc=$OPTARG;;
132         (w)     set -x;;
133         (h)     show_usage=1;;
134         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
135         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
136     esac
137 done
138
139 shift $((OPTIND-1))
140
141 function usage() {
142     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
143     echo >&2 "Revision $REV"
144     echo >&2 "Options:"
145     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
146     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
147     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
148     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
149     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
150     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
151     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
152     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
153     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
154     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
155     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
156     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
157     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
158     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
159     echo >&2 "                 Handbrake Only Encoder Profiles:"
160     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
161     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
162     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
163     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
164     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
165     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
166     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
167     echo >&2 "                 The default operation is non-mirror mode where only the main"
168     echo >&2 "                 feature title will be ripped."
169     echo >&2 "   -v            Make the final image a DVD VOB file"
170     echo >&2 "   -i            Make the final image a DVD ISO file"
171     echo >&2 "   -f            Make the final image a DVD folder"
172     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
173     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
174     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
175     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
176     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
177     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
178     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
179     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
180     echo >&2 "   -j <n>        Eject the disk:"
181     echo >&2 "                 - 0 = do not eject the disk"
182     echo >&2 "                 - 1 = eject after the entire script is done (default)"
183     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
184     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
185     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
186     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
187     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
188     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
189     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
190     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
191     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
192     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
193     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
194     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
195     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
196     echo >&2 ""
197     exit 2
198 }
199
200 if (($errors)) || (($show_usage))
201 then
202   usage
203 fi
204
205 # Sanity Check - Command Line Options 
206 if [ "$dest" == "" ]; then
207   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
208   usage
209 fi
210
211 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
212    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
213     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
214     make_final_dest_comp=1
215 fi
216
217 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
218   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
219   usage
220 fi
221
222 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
223   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
224   usage
225 fi
226
227 if [ $mirror_mode -eq 1 ]; then
228   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
229      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
230     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
231     usage
232   fi
233 fi
234
235 # Make handbrake the default encoder if not specified and we can find it
236 if [ -z "$encoder" ]; then
237   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
238   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
239   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
240   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
241   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
242 fi
243
244 # Sanity check the profile selection
245 if [[ "$encoder" == "mencoder" ]]; then
246   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
247 fi
248
249 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
250   echo "-E- Invalid encoder specified: $encoder"
251   exit 1
252 fi
253
254 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
255 if [ "$aspect" != "" ]; then
256   echo "$aspect" | grep -q "x"
257   if [ $? == 0 ]; then
258     echo "-E- You must specify the aspect option with a value whose format is W:H"
259     exit 1
260   fi
261   echo "$aspect" | grep -q ":"
262   if [ $? != 0 ]; then
263     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
264     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
265   else
266     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
267     if [ "$encoder" == "handbrake" ]; then
268        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
269        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
270        SCALE="-w $WIDTH -l $HEIGHT"
271     fi
272   fi
273 fi
274
275 # Sanity Check - Key executables
276 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
277 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
278 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
279 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
280 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
281 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
282 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
283 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
284 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
285 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
286 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
287 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
288 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
289
290 ##############################################################################################
291
292 typeset -i ripdvd
293 if [ -z "$dvdname" ]; then
294
295   # make sure the DVD device is accessible
296   volname $dev > /dev/null 2>&1
297   if [ $? != 0 ]; then
298     echo "-E- Can't access the DVD device $dev"
299     exit 1
300   fi
301   # now capture the volume name from the device
302   dvdname=`volname $dev | awk '{ print $1 }'`
303   ripdvd=1
304
305 else 
306
307   # check to see if dvdname is a full path to a real directory
308   # if it is, set dvdname and dvdpath appropriately
309   if [ -d "$dvdname" ]; then
310     dvdpath="$dvdname"
311     dvdname=`basename "$dvdname"`
312     keep_dvdfolder=1
313     if [ -z "$dvdname" ]; then
314      echo "-E- Unable to extract dvdname from path: $dvdpath"
315      exit 1
316     fi
317     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
318       echo "-E- You must supply a full path to a valid DVD folder with this option"
319       exit 1
320     fi
321   fi
322
323   # Check to see if dvdname is a full path to a file
324   if [ -f "$dvdname" ]; then
325     valid_file=0
326
327     # check to see if dvdname is a full path to an MPG2 (VOB) file
328     # if it is, set dvdname and vobfile appropriately
329     file "$dvdname" | grep -q "MPEG"
330     if [ $? == 0 ]; then
331       # It is a valid MPEG2 file, now strip the extension off our dvdname
332       vobfile="$dvdname"
333       dvdname=`basename "$dvdname"`
334       dvdname=${dvdname%.[^.]*}
335       keep_vobfile=1
336       valid_file=1
337     fi
338
339     # check to see if dvdname is a full path to an ISO file
340     # if it is, set dvdname and isofile appropriately
341     file "$dvdname" | grep -q -e "ISO" -e "UDF"
342     if [ $? == 0 ]; then
343       # It is a valid ISO file, now strip the extension off our dvdname
344       isofile="$dvdname"
345       dvdname=`basename "$dvdname"`
346       dvdname=${dvdname%.[^.]*}
347       keep_isofile=1
348       valid_file=1
349     fi    
350
351     # check to see if dvdname is a full path to an ISO file
352     # if it is, set dvdname and isofile appropriately
353     file "$dvdname" | grep -q -e "VOB"
354     if [ $? == 0 ]; then
355       # It is a valid VOB file, now strip the extension off our dvdname
356       vobfile="$dvdname"
357       dvdname=`basename "$dvdname"`
358       dvdname=${dvdname%.[^.]*}
359       keep_vobfile=1
360       valid_file=1
361     fi    
362
363     # If we didn't find a handler for the file above, complain
364     if [ $valid_file -eq 0 ]; then
365       echo "-E- Unsupported file type: $vobfile"
366       exit 1
367     fi
368
369   # Throw an error if we can't find what the -n option is pointing to
370   else 
371     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
372     exit 1
373   fi
374
375   # Set the ripdvd flag to false since we aren't ripping a DVD disk
376   ripdvd=0
377
378   # Since we aren't ripping a DVD disk, don't eject anything either
379   eject_disk=0
380
381 fi
382
383 # remove bad characters from the dvdname
384 dvdname=${dvdname%.} # remove trailing '.' character
385
386 # add the suffix extension to the end of the dvdname
387 dvdname=$dvdname$extension
388
389 # make a "safe" dvdname (remove special characters)
390 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
391
392 # Make sure we have a non-empty dvdname
393 if [ -z "$dvdname" ]; then
394   echo "-E- unable to determine dvdname"
395   exit 1
396 fi
397
398 # make sure our vobfile value is set
399 if [ -z "$vobfile" ]; then
400   vobfile="$dest/$dvdname.VOB"
401 fi
402
403 # set up some variables to hold various logfiles
404 logfile="$logdir/$dvdname.log"
405 passlogfile="$tmpdir/$safedvdname.log"
406 ddrescuelog=`tempfile`
407 dvdauthorlog=`tempfile`
408 encodelog=`tempfile`
409 dumplog=`tempfile`
410
411 # create the tmpdir if it doesn't already exist
412 if [ ! -d "$tmpdir" ]; then
413   mkdir -p "$tmpdir"
414   if [ $? != 0 ]; then
415     echo "-E- Unable to create the tmpdir: $tmpdir"
416     exit 1
417   fi
418 fi
419
420 # create the logdir if it doesn't already exist
421 if [ ! -d "$logdir" ]; then
422   mkdir -p "$logdir"
423   if [ $? != 0 ]; then
424     echo "-E- Unable to create the logdir: $logdir"
425     exit 1
426   fi
427 fi
428
429 ##############################################################################################
430 # cleanup functions
431 ##############################################################################################
432 cleanup() { 
433   if [ $keep_intermediate_files -eq 0 ]; then
434     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
435     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
436     [[ -e "$encodelog" ]] && rm -f "$encodelog"
437     [[ -e "$dumplog" ]] && rm -f "$dumplog"
438   else
439     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
440     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
441     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
442     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
443   fi
444   echo ""
445 }
446
447 fatal_and_exit() {
448   if [[ -z "$1" ]]; then
449     msg="-E- control-c killed us"
450   else
451     msg=$1
452   fi
453   echo -e 2>&1 "$msg" | tee -a "$logfile"
454   if [[ -n "$mailto" ]]; then
455     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
456   fi
457   keep_intermediate_files=1
458   exit 1
459 }
460
461 # Call our cleanup functions on INT and EXIT signals
462 trap fatal_and_exit INT
463 trap cleanup EXIT
464
465 ##############################################################################################
466 # processing functions
467 ##############################################################################################
468
469 # encode the vob file into a compressed file format using handbrake
470 function encode_vob_file_handbrake {
471   
472   # declare some globals
473   typeset handbrake_cli=""
474   typeset handbrake_video_encoder_opts=""
475   typeset filetype=""
476   typeset handbrake_audio_opts=""
477   typeset hb_profile=""
478   typeset SIZE=""
479
480   # Set a variable that we will use later to determine if we found a handler for $profile or not
481   typeset -i found_profile=0    
482
483   # For a given profile, to override the 2 pass behavior to be single pass,
484   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
485   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
486   PASSES="-2"
487
488   # Set our DRC option
489   DRC="-D $drc"
490
491   if [ $target_size -ne 0 ]; then
492     SIZE="-S $target_size"
493   fi 
494
495   # Check the global force_onepass_mode. If it is set, change our variables appropriately
496   # to force 1-pass encoding across all profiles.
497   if [ $force_onepass_mode -eq 1 ]; then
498     PASSES=""
499   fi
500
501   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
502   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
503
504   # XVID profile
505   if [[ "$profile" =~ "xvid" ]]; then
506     found_profile=1
507     handbrake_cli="$handbrake_xvid"
508     final_output_file="$dest/$dvdname.avi"
509     filetype="avi"
510
511     # Very High Quality (16fps)
512     if [ "$profile" == "xvidvhq" ]; then
513       handbrake_opts[0]="-f avi"
514       handbrake_opts[1]="-b $target_bitrate"
515       handbrake_opts[2]="-e xvid"
516       handbrake_opts[3]="-T"
517       handbrake_opts[4]="-5"
518       handbrake_opts[5]="-8"
519     fi
520     # High Quality (20fps)
521     if [ "$profile" == "xvidhq" ]; then
522       handbrake_opts[0]="-f avi"
523       handbrake_opts[1]="-b $target_bitrate"
524       handbrake_opts[2]="-e ffmpeg"
525       handbrake_opts[3]="-T"
526       handbrake_opts[4]="-5"
527     fi
528     # Fast (28fps)
529     if [ "$profile" == "xvid" ]; then
530       handbrake_opts[0]="-f avi"
531       handbrake_opts[1]="-b $target_bitrate"
532       handbrake_opts[2]="-e ffmpeg"
533       handbrake_opts[3]="-T"
534     fi
535   fi
536
537   # MP4 profile
538   if [[ "$profile" =~ "mp4" ]]; then
539     found_profile=1
540     handbrake_cli="$handbrake_mp4"
541     final_output_file="$dest/$dvdname.mp4"
542     PASSES=""
543
544     # Handle custom parameter overrides
545     if [ $custom_bitrate == 1 ]; then
546       handbrake_opts[0]="-b $target_bitrate"
547     fi
548     if [ $custom_audio_2ch == 0 ]; then
549       audio_2ch=0
550     fi
551     if [ $custom_audio_6ch == 0 ]; then
552       audio_6ch=0
553     fi
554
555     # Very High Quality
556     if [ "$profile" == "mp4vhq" ]; then
557       profile="hb_High_Profile"
558     fi
559     # High Quality
560     if [ "$profile" == "mp4hq" ]; then
561       profile="hb_Normal"
562     fi
563     # Fast
564     if [ "$profile" == "mp4" ]; then
565       profile="hb_Classic"
566     fi
567   fi
568
569   # iphone and ipod MP4 profiles
570   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
571     found_profile=1
572     handbrake_cli="$handbrake_mp4"
573     final_output_file="$dest/$dvdname.mp4"
574     PASSES=""
575
576     # Handle custom parameter overrides
577     if [ $custom_bitrate == 1 ]; then
578       handbrake_opts[0]="-b $target_bitrate"
579     fi
580     if [ $custom_audio_2ch == 0 ]; then
581       audio_2ch=0
582     fi
583     if [ $custom_audio_6ch == 0 ]; then
584       audio_6ch=0
585     fi
586
587     # iphone
588     if [ "$profile" == "iphone" ]; then
589       profile="hb_iPhone_&_iPod_Touch"
590     fi
591     # ipod
592     if [ "$profile" == "ipod" ]; then
593       profile="hb_iPod"
594     fi
595
596   fi
597   
598   # Predefined Handbrake Profile Handling
599   if [[ "$profile" =~ "hb" ]]; then
600     found_profile=1
601     handbrake_cli="$handbrake_mp4"
602     final_output_file="$dest/$dvdname.mp4"
603     PASSES=""
604
605     # Handle custom parameter overrides
606     if [ $custom_bitrate == 1 ]; then
607       handbrake_opts[0]="-b $target_bitrate"
608     fi
609     if [ $custom_audio_2ch == 0 ]; then
610       audio_2ch=0
611     fi
612     if [ $custom_audio_6ch == 0 ]; then
613       audio_6ch=0
614     fi
615     
616     # extract the HandBrake Profile name from $profile
617     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
618   fi
619
620   # Make sure we found a handler for the given profile
621   if [ $found_profile -eq 0 ]; then
622     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
623   fi
624
625   # setup our audio option
626   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
627     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
628   fi
629   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
630     handbrake_audio_opts="-E ac3 -6 auto"
631   fi
632   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
633     handbrake_audio_opts="-E faac -6 dpl2"
634   fi
635   if [ -n "$track" ]; then
636     handbrake_audio_opts="$handbrake_audio_opts -a $track"
637   fi
638
639   # Convert our array of opts into a string
640   for OPTS in "${video_encoder_opts[@]}"; do 
641     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
642   done
643   if [ -n "$handbrake_video_encoder_opts" ]; then
644     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
645   fi
646   for OPTS in "${handbrake_opts[@]}"; do 
647     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
648   done
649
650   # Append "global" command line options
651   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
652   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
653   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
654   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
655   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
656
657   # Execute the handbrake command to encode the video
658   if [ -n "$hb_profile" ]; then
659     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
660     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
661     handbrake_retval=$?
662   else 
663     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
664     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
665     handbrake_retval=$?
666   fi
667   if [ $handbrake_retval != 0 ]; then
668     fatal_and_exit "-E- Unhandled handbrake error"
669   fi
670
671   # Concatenate the encode log to our main log file, greping out unwanted lines
672   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
673   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
674   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
675 }
676
677 # encode the vob file into a compressed file format using mencoder
678 function encode_vob_file_mencoder {
679
680   # Set a variable that we will use later to determine if we found a handler for $profile or not
681   typeset -i found_profile=0
682
683   # For a given profile, to override the 2 pass behavior to be single pass,
684   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
685   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
686   PASSES="1 2"
687
688   # Declare our default 2 pass variables
689   passlogfile_opt="-passlogfile $passlogfile"
690   pass_opt="pass=%PASS"
691
692   # Check the global force_onepass_mode. If it is set, change our variables appropriately
693   # to force 1-pass encoding across all profiles.
694   if [ $force_onepass_mode -eq 1 ]; then
695     PASSES="2"
696     passlogfile_opt=""
697     pass_opt=""    
698   fi
699
700   # XVID profile
701   if [[ "$profile" =~ "xvid" ]]; then
702     found_profile=1
703     final_output_file="$dest/$dvdname.avi"
704     mencoder_general_opts="$lang_opts $passlogfile_opt"
705     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
706     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
707     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
708
709     # Very High Quality (16fps)
710     if [ "$profile" == "xvidvhq" ]; then
711       video_encoder_opts[0]="bitrate=$target_bitrate"
712       video_encoder_opts[1]="threads=$mencoder_threads"
713       video_encoder_opts[2]="chroma_opt"
714       video_encoder_opts[3]="vhq=4"
715       video_encoder_opts[4]="bvhq=1"
716       video_encoder_opts[5]="quant_type=mpeg"
717       video_encoder_opts[6]="autoaspect"
718     fi
719     # High Quality (20fps)
720     if [ "$profile" == "xvidhq" ]; then
721       video_encoder_opts[0]="bitrate=$target_bitrate"
722       video_encoder_opts[1]="threads=$mencoder_threads"
723       video_encoder_opts[2]="chroma_opt"
724       video_encoder_opts[3]="vhq=2"
725       video_encoder_opts[4]="bvhq=1"
726       video_encoder_opts[5]="quant_type=mpeg"
727       video_encoder_opts[6]="autoaspect"
728     fi
729     # Fast (28fps)
730     if [ "$profile" == "xvid" ]; then
731       video_encoder_opts[0]="bitrate=$target_bitrate"
732       video_encoder_opts[1]="threads=$mencoder_threads"
733       video_encoder_opts[2]="vhq=0"
734       video_encoder_opts[3]="turbo"
735       video_encoder_opts[4]="autoaspect"
736     fi
737
738     for OPTS in "${video_encoder_opts[@]}"; do 
739       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
740     done
741
742     if [ $audio_2ch -eq 0 ]; then
743       # These options produce good 6 channel audio for linux and windows
744       mencoder_audio_opts="-oac copy"
745       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
746       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
747       mencoder_audioch_opts[1]="-af channels=6"
748       mencoder_audioch_opts[2]=""
749     else
750       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
751       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
752       mencoder_audioch_opts[0]=""
753     fi
754  
755   fi
756
757   # iphone and ipod MP4 profiles
758   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
759     found_profile=1
760     if [ "$profile" == "iphone" ]; then
761       # SCALE: 480x320
762       # scale width to 480, set height appropriately, but keep a multiple of 16
763       #SCALE=",scale=480:-10"
764       # scale the video down however far is necessary to fit in 480x320
765       SCALE=",dsize=480:320:0,scale=-8:-8"
766     else
767       # SCALE: 320x240
768       # scale width to 320, set height appropriately, but keep a multiple of 16
769       #SCALE=",scale=320:-10"
770       # scale the video down however far is necessary to fit in 320x240
771       SCALE=",dsize=320:240:0,scale=-8:-8"
772     fi
773     final_output_file="$dest/$dvdname.mp4"
774     mencoder_general_opts="$lang_opts $passlogfile_opt"
775     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
776     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
777     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
778     video_encoder_opts[0]="bitrate=$target_bitrate"
779     video_encoder_opts[1]="threads=$mencoder_threads"
780     video_encoder_opts[2]="vbv_maxrate=1500"
781     video_encoder_opts[3]="vbv_bufsize=2000"
782     video_encoder_opts[4]="nocabac"
783     video_encoder_opts[5]="me=umh"
784     video_encoder_opts[6]="subq=6"
785     video_encoder_opts[7]="frameref=6"
786     video_encoder_opts[8]="trellis=1"
787     video_encoder_opts[9]="level_idc=30"
788     video_encoder_opts[10]="global_header"
789     video_encoder_opts[11]="bframes=0"
790     video_encoder_opts[12]="partitions=all"
791     for OPTS in "${video_encoder_opts[@]}"; do 
792       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
793     done
794
795     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
796     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
797   fi
798
799   if [ $found_profile -eq 0 ]; then
800     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
801   fi
802
803   # Do not edit this line. $mencoder_video_encoder_opts must be last
804   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
805   mencoder_retval=0
806
807   for PASS in $PASSES
808   do 
809     # Set some options based on which pass we are in
810     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
811     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
812     [ $PASS -eq 1 ] && output_file="/dev/null"
813     [ $PASS -eq 2 ] && output_file="$final_output_file"
814   
815     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
816     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
817     do
818       echo -e "   Encoding pass $PASS"
819       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
820       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
821       mencoder_retval=$? 
822       grep -q "\[channels\] Invalid" $encodelog
823       if [ $? != 0 ]; then          
824         break;
825       else
826         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
827       fi
828     done
829       
830     if [ $mencoder_retval != 0 ]; then
831       fatal_and_exit "-E- Unhandled mencoder error"
832     fi
833
834     # Concatenate the encode log to our main log file, greping out unwanted lines
835     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
836
837   done
838 }
839
840 function make_dvd_iso_image {
841
842   isofile="$1"
843
844   # check to see if we have a dvdpath to rip from instead of $dev
845   if [ -z "$dvdpath" ]; then
846     # load the CSS codes in the DVD drive 
847     lsdvd $dev >> "$logfile"
848     if [ $? != 0 ]; then
849       fatal_and_exit "-E- lsdvd $dev failed" 
850     fi
851
852     # read the DVD, ignoring/skipping CRC errors
853     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
854     if [ $? != 0 ]; then
855       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
856     fi
857     cat "$ddrescuelog" >> "$logfile"
858   else
859     # rip from a path instead
860     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
861   fi
862 }
863
864 function make_dvd_iso_image_from_folder {
865   
866   src="$1"
867   dst="$2"
868   handle_error=$3
869   
870   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
871
872   # make an iso image out of our directory
873   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
874   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
875
876   # set the audio languages from the iso if it exists and is non-zero in size
877   if [ -s "$dst" ]; then
878     get_feature_title "$dst"
879     get_audio_id_from_iso "$dst"
880   fi
881
882   # make sure we were able to create the iso image from the folder given to us
883   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
884     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
885     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
886     # remove the bad iso file
887     [[ -e "$dst" ]] && rm -f "$dst"
888     # get the feature title from the DVD folder
889     get_feature_title "$dvdpath"
890     # create our main VOB file from the ISO
891     create_main_vob_with_mplayer "$dvdpath" 
892     # get our audio id from the VOB file
893     get_audio_id_from_vob "$vobfile"
894   fi
895 }
896
897 function make_dvdbackup_folder_image {
898   # extract the feature title from the DVD image
899   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
900   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
901   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
902   if [ $? != 0 ]; then
903     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
904   fi
905 }
906
907 function make_dvdauthor_folder_image {
908   # create a new DVD video of the feature title
909   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
910   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
911   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
912   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
913
914   # There is a chance that dvdauthor won't like some of the VOBs.
915   # We can't tell ahead of time which ones it will choke on. 
916   # So, we need to run it over and over again until it can process
917   # all the VOBs. If it can't handle one of them, run it through
918   # mencoder to fix it and try again. These errors are typically
919   # present due to the copy protection that ddrescue removed.
920   grep -q "SCR moves" $dvdauthorlog
921   while [ $? == 0 ]; do
922     # fix bad vobs that get the "SCR moves backwards" error:
923     #  STAT: Processing VTS_01_0.VOB...
924     #  ERR:  SCR moves backwards, remultiplex input.
925     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
926     if [[ ! -f "$badvob" ]]; then
927       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
928     fi
929     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
930     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
931     mv -f $badvob.fixed $badvob
932     echo "-> Creating DVD video $dest/$dvdname"
933     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
934     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
935     grep -q "SCR moves" $dvdauthorlog
936   done
937 }
938
939 function get_feature_title {
940   source="$1"
941   # if a feature title was given on the command line, use it
942   if [ $feature_title_override -ne 0 ]; then
943     feature_title=$feature_title_override
944     return 0
945   fi
946   # otherwise, use lsdvd to figure it out
947   if [ $ripdvd -eq 1 ]; then
948     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
949   else 
950     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
951   fi
952 }
953
954 function create_main_vob_with_cat {
955   # cd to the feature title DVD folder
956   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
957   if [ $? != 0 ]; then
958     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
959   fi
960
961   # concatenate all the VOBs together into 1 giant VOB
962   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
963   cat $vobs > "$tmpdir/$dvdname.VOB"
964
965   # cd back to the dir we started from
966   popd > /dev/null 2>&1
967 }
968
969 function create_main_vob_with_mplayer {
970
971   # argument processing  
972   source="$1"
973   remove_dumplog=$2
974
975   # make sure we have a valid feature title
976   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
977     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
978   fi
979
980   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
981   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
982     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
983     msg="$msg We also detected another condition that requires us to use dumpstream. "
984     msg="$msg\n    Unable to rip this DVD in the mode you requested."
985     fatal_and_exit "$msg"
986   fi
987
988   # use mplayer to create the main VOB file
989   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
990   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
991   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
992   if [ $? != 0 ]; then
993     cat $dumplog | grep -v "^A:" >> "$logfile"
994     fatal_and_exit "-E- Mplayer Failed"
995   fi
996   cat $dumplog | grep -v "^A:" >> "$logfile"
997   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
998 }
999
1000 function get_audio_id_from_iso {
1001   # Adjust our audio ID to find the english audio stream
1002   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1003   iso="$1"
1004   aidcheck=`tempfile`
1005   aid=$default_aid
1006   alang=$default_alang
1007   if [ $aid_override -lt 0 ]; then 
1008     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1009     grep -q "aid: $aid" $aidcheck
1010     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1011       (( aid = aid + 1 ))
1012       grep -q "aid: $aid" $aidcheck
1013     done
1014     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1015   else
1016     aid=$aid_override
1017   fi
1018   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1019   # mencoder default DVD audio track language selection (english)
1020   lang_opts="-aid $aid -alang $alang"
1021 }
1022
1023 function get_crop_from_iso { 
1024   FRAMES=10000
1025   echo "-> Detecting black frame border crop value from ISO file"
1026   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1027   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1028   [[ -e "md5sums" ]] && rm -f "md5sums"
1029   CROP=`cat $dumplog | grep CROP | tail -1`
1030   echo "   Found crop value of $CROP" >> "$logfile"
1031   CROP=${CROP#* crop=}
1032   CROP=${CROP%%\).*}
1033   typeset -i CROPCHECK
1034   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1035   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1036   if [ -z "$CROP" ]; then
1037     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1038     return
1039   fi
1040   if [ $CROPCHECK -lt 0 ]; then 
1041     CROP=""
1042   else 
1043     CROP=",crop=$CROP"
1044   fi
1045   echo "   Setting mencoder crop filter to: $CROP"
1046 }
1047
1048 function get_crop_from_vob { 
1049   FRAMES=10000
1050   echo "-> Detecting black frame border crop value from VOB file"
1051   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1052   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1053   [[ -e "md5sums" ]] && rm -f "md5sums"
1054   CROP=`cat $dumplog | grep CROP | tail -1`
1055   echo "   Found crop value of $CROP" >> "$logfile"
1056   CROP=${CROP#* crop=}
1057   CROP=${CROP%%\).*}
1058   typeset -i CROPCHECK
1059   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1060   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1061   if [ -z "$CROP" ]; then
1062     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1063     return
1064   fi
1065   if [ $CROPCHECK -lt 0 ]; then 
1066     CROP=""
1067   else 
1068     CROP=",crop=$CROP"
1069   fi
1070   echo "   Setting mencoder crop filter to: $CROP"
1071 }
1072
1073 function get_audio_track_from_vob {
1074   # Adjust our audio ID to find the english audio stream
1075   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1076   vob="$1"
1077   handbrake_cli="$2"
1078   aidcheck=`tempfile`
1079   aid=$default_aid
1080   alang=$default_alang
1081   if [ $aid_override -lt 0 ]; then 
1082     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1083     grep -q "Found audio stream: $aid" $aidcheck
1084     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1085       (( aid = aid + 1 ))
1086       grep -q "Found audio stream: $aid" $aidcheck
1087     done
1088     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1089   else 
1090     aid=$aid_override
1091   fi
1092   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1093
1094   # convert the aid we found into hex
1095   aid_hex=`echo "obase=16; $aid" | bc`
1096   
1097   # extract the audio streams in the vob
1098   #ffmpeg -i "$vob" > $aidcheck 2>&1
1099   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1100   
1101   # find the stream that matches our aid
1102   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1103   #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1104   stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
1105  
1106   # extract the track number that handbrake uses
1107   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1108   track=`expr match "$stream" '^\([0-9]*\):'`
1109
1110   if [ -n "$track" ]; then   
1111     echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1112   fi
1113 }
1114
1115 function get_audio_id_from_vob {
1116   # Adjust our audio ID to find the english audio stream
1117   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1118   vob="$1"
1119   aidcheck=`tempfile`
1120   aid=$default_aid
1121   alang=$default_alang
1122   if [ $aid_override -lt 0 ]; then 
1123     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1124     grep -q "Found audio stream: $aid" $aidcheck
1125     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1126       (( aid = aid + 1 ))
1127       grep -q "Found audio stream: $aid" $aidcheck
1128     done
1129     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1130   else 
1131     aid=$aid_override
1132   fi
1133   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1134   # mencoder default DVD audio track language selection (english)
1135   lang_opts="-aid $aid -alang $alang"
1136 }
1137
1138 function check_vob_for_corrupted_start {
1139   # check to see if the beginning of the DVD has a form of copy protection
1140   # where they have deliberately broken the first X number of frames of the DVD.
1141   # If we don't skip these, our resulting VOB file will not play.
1142   badvobcheck=`tempfile`
1143   endpos=360
1144   skip=0
1145   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1146   if [ $? != 0 ]; then
1147     fatal_and_exit "-E- Mencoder Failed"
1148   fi
1149   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1150   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1151     (( skip = skip + 5 ))
1152     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1153     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1154     if [ $? != 0 ]; then
1155       fatal_and_exit "-E- Mencoder Failed"
1156     fi
1157     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1158   done
1159   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1160
1161   # cat the giant VOB into mencoder to create a playable VOB file
1162   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1163   if [ $? != 0 ]; then
1164     fatal_and_exit "-E- Mencoder Failed"
1165   fi
1166 }
1167
1168 function check_vob_for_completeness {
1169   # check to make sure we got out a complete VOB.
1170   # there is another kind of copy protection where the VOB's may
1171   # have "MPG EOF" frames in the middle of the stream. 
1172   # this causes mencoder to not process the entire VOB, and exit without any errors.
1173   # detect this by seeing how much smaller the dst vob is from the src vob.
1174   MAX_FILESIZE_DELTA_PERCENT=70
1175   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1176   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1177   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1178   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1179     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1180     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1181     create_main_vob_with_mplayer "$isofile"
1182     [[ -e "$dumplog" ]] && rm -f $dumplog
1183     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1184     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1185     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1186       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1187     fi
1188   fi
1189 }
1190
1191 function check_vob_for_too_many_video_packets {
1192   # If our earlier algorithm to work around this failed, throw an error.
1193   # check to see if this DVD has a protection scheme we don't know how to work around
1194   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1195   # for some reason, the video is black, while the audio rolls, then the video finally comes
1196   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1197   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1198   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1199   grep -q "Too many video packets in the buffer:" "$logfile"
1200   if [ $? == 0 ]; then
1201     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1202     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1203     create_main_vob_with_mplayer "$isofile"
1204     grep -q "Too many video packets in the buffer:" $dumplog
1205     if [ $? == 0 ]; then
1206       [[ -e "$dumplog" ]] && rm -f $dumplog
1207       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1208     fi
1209     [[ -e "$dumplog" ]] && rm -f $dumplog
1210   fi
1211 }
1212
1213 function check_vob_for_a52_crc_errors {
1214   # Let's see if we can playback our newly created VOB file without any errors.
1215   # if there are issues, let's detect them now, and try to recreate the VOB
1216   # there are some forms of copy protection that have missed above, that evidence
1217   # themselves when we try to playback the VOB file. This was added to deal with
1218   # the "a52: CRC check failed" copy protection scheme.
1219   MAX_ERRORS=10
1220   ENDPOS=120
1221   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1222   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1223   cat $dumplog | grep -v "^A:" >> "$logfile"
1224   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1225   if [ $errors -gt $MAX_ERRORS ]; then
1226     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1227     create_main_vob_with_mplayer "$isofile"
1228     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1229     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1230     if [ $? != 0 ]; then
1231       cat $dumplog | grep -v "^A:" >> "$logfile"
1232       fatal_and_exit "-E- Mplayer Failed"
1233     fi
1234     cat $dumplog | grep -v "^A:" >> "$logfile"
1235     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1236     if [ $errors -gt $MAX_ERRORS ]; then
1237       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1238     fi
1239   fi
1240   [[ -e "$dumplog" ]] && rm -f $dumplog
1241 }
1242
1243 function calculate_bitrate_from_target_size {
1244   # determine what our bitrate needs to be if a target size was specified instead
1245   if [ $target_size -ne 0 ]; then
1246     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1247     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1248     custom_bitrate=1
1249     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1250   fi
1251 }
1252
1253 function create_dvdauthor_dvd_xml_file {
1254   # make a dvdauthor xml menu file to create a valid DVD video from 
1255   # this script does a good job, but we'll still need to clean it up a bit after it runs
1256   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1257   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1258   if [ $? != 0 ]; then
1259     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1260   fi
1261
1262   # replace the first line of the xml file to remove the bad dest path
1263   awk -v line=1 -v new_content="<dvdauthor>" '{
1264     if (NR == line) {
1265       print new_content;
1266     } else {
1267       print $0;
1268     }
1269   }' dvd.xml > dvd.xml.new
1270   mv -f dvd.xml.new dvd.xml
1271   if [ $? != 0 ]; then
1272     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1273   fi
1274
1275   # remove the "<video " property line from the xml file
1276   cat dvd.xml | grep -v "<video" > dvd.xml.new
1277   mv -f dvd.xml.new dvd.xml
1278   if [ $? != 0 ]; then
1279     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1280   fi
1281   
1282   # remove the extra <pgc>..</pgc> pairs
1283   cat dvd.xml | awk 'BEGIN {x=1}
1284   {
1285     if ($0~"</pgc>") {x=0}
1286     if (x==1) {print $0}
1287     if ($0~"<pgc>") {x=1}
1288   }' > dvd.xml.new
1289   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1290   mv -f dvd.xml.new dvd.xml
1291   if [ $? != 0 ]; then
1292     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1293   fi
1294
1295   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1296   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1297   mv -f dvd.xml.new dvd.xml
1298   if [ $? != 0 ]; then
1299     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1300   fi
1301 }
1302
1303 function check_for_mplayer_dumpstream_incompatibility {
1304
1305   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1306
1307   if [ ! -e "$vobfile" ]; then
1308     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1309     # A DVD that has 99 titles, where the longest title isn't the main feature
1310     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1311     # out what the feature title is. This script will run through that flow if we
1312     # set use_mplayer_dumpstream to 0. Check for this here.
1313     if [ $ripdvd -eq 1 ]; then
1314       lsdvd $dev | grep -q "Title: 99"
1315     else
1316       lsdvd "$isofile" | grep -q "Title: 99"
1317     fi
1318     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1319     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1320       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1321         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1322         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1323         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1324         invalid_feature_title=1
1325       else 
1326         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1327         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1328         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1329         use_mplayer_dumpstream=0
1330         invalid_feature_title=1
1331       fi
1332       return
1333     fi
1334   fi
1335
1336   # There is another form of protection that causes the mplayer dumpstream to fail. 
1337   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1338   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1339   # problem before continuing.
1340   if [ -e "$vobfile" ]; then
1341     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1342     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1343     grep -q "Too many audio packets in the buffer" $dumplog
1344     if [ $? == 0 ]; then
1345       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1346       use_mplayer_dumpstream=0
1347       mplayer_dumpstream_incompatibility=1
1348     fi
1349     [[ -e "$dumplog" ]] && rm -f $dumplog
1350   fi
1351 }
1352
1353 function fill_mythvideo_metadata {
1354
1355   # This function must be passed the filename as an argument
1356   # The filename must be a full path to the file
1357   filename="$1"
1358
1359   # Make sure the fill mythvideo metadata option has been set to 1
1360   if [ $fill_mythvideo_metadata -eq 0 ]; then
1361     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1362     return 0
1363   fi
1364
1365   # If the fill mythvideo metadata script is present, run it
1366   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1367   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1368     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1369     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1370   else
1371     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1372     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1373   fi
1374 }
1375
1376 # remove the intermediate VOB file
1377 function remove_intermediate_vob_file {
1378   if [ $keep_intermediate_files -eq 0 ]; then
1379     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1380   else
1381     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1382   fi
1383 }
1384
1385 # remove the original DVD image 
1386 function remove_intermediate_iso_file {
1387   [[ $keep_isofile -eq 1 ]] && return 1
1388   if [ $keep_intermediate_files -eq 0 ]; then
1389     [[ -e "$isofile" ]] && rm "$isofile"
1390   else
1391     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1392   fi
1393 }
1394
1395 # remove the intermediate dvdbackup folder
1396 function remove_intermediate_dvdbackup_folder {
1397   if [ $keep_intermediate_files -eq 0 ]; then
1398     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1399   else
1400     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1401   fi
1402 }
1403
1404 ##############################################################################################
1405 # MAIN
1406 ##############################################################################################
1407
1408 # Make a note of when this DVD rip started
1409 date=`date`
1410 echo -e "\n$date DVD rip started" >> "$logfile"
1411 echo "$cmd" >> "$logfile"
1412
1413 # Rip the DVD - Mirror Mode
1414 if [ $mirror_mode -eq 1 ]; then
1415   echo "-> Ripping DVD $dvdname to $dest"
1416
1417   # use ddrescue to make an ISO image of the disk
1418   make_dvd_iso_image "$dest/$dvdname.iso"
1419
1420   # add this video data to the mythtv DB
1421   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1422
1423   # eject the disk upon completion
1424   if [ $eject_disk -ne 0 ]; then
1425     eject -T $dev
1426   fi
1427
1428   date=`date`
1429   echo "$date DVD rip completed" | tee -a "$logfile"
1430
1431   if [[ -n "$mailto" ]]; then
1432     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1433   fi
1434
1435 fi
1436
1437 # Rip the DVD - Main Title Feature Only
1438 if [ $mirror_mode -eq 0 ]; then
1439
1440   # Rip image from DVD
1441   if [ $ripdvd -eq 1 ]; then
1442     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1443     # use ddrescue to make an ISO image of the disk
1444     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1445   fi
1446
1447   # Rip image from DVD path
1448   if [ -n "$dvdpath" ]; then
1449     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1450     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1451   fi
1452
1453   # make sure our isofile value is set
1454   if [ -z "$isofile" ]; then
1455     isofile="$tmpdir/$dvdname.iso"
1456   fi
1457      
1458   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1459
1460     if [ ! -e "$vobfile" ]; then
1461       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1462       
1463       # get the feature title from the ISO
1464       get_feature_title "$isofile"
1465  
1466       # get the crop value from the ISO
1467       get_crop_from_iso
1468
1469       # check for mplayer dumpstream incompatibilities
1470       # if they exist, this method will set this mode to 0.
1471       check_for_mplayer_dumpstream_incompatibility
1472
1473       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1474
1475         # get our audio id from the ISO file
1476         get_audio_id_from_iso "$isofile"
1477
1478         # create our main VOB file from the ISO
1479         create_main_vob_with_mplayer "$isofile"
1480      
1481         # remove the intermediate VOB file
1482         remove_intermediate_vob_file
1483
1484         # it's possible that our VOB is still corrupted in some manner
1485         # check to make sure it is still a good VOB before continuing.
1486         check_for_mplayer_dumpstream_incompatibility
1487
1488       fi
1489  
1490       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1491
1492         # use dvdbackup to make a DVD folder of the feature title
1493         make_dvdbackup_folder_image
1494   
1495         # create our main VOB file
1496         create_main_vob_with_cat
1497
1498         # get our audio id from the VOB file
1499         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1500   
1501         # check for corrupted VOB start
1502         check_vob_for_corrupted_start
1503  
1504         # check to make sure our VOB is complete
1505         check_vob_for_completeness
1506
1507         # check to make sure our VOB doesn't have too many video packets
1508         check_vob_for_too_many_video_packets
1509
1510         # check to make sure our VOB doesn't have a52 crc errors
1511         check_vob_for_a52_crc_errors
1512
1513         # remove the intermediate VOB file
1514         remove_intermediate_vob_file
1515
1516       fi
1517
1518       # remove the intermediate ISO file
1519       remove_intermediate_iso_file
1520
1521     else
1522       if [ "$encoder" != "handbrake" ]; then 
1523         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1524         # get our audio id from the VOB file
1525         get_audio_id_from_vob "$vobfile"
1526         # get the crop value from the VOB
1527         get_crop_from_vob
1528       fi
1529     fi
1530
1531     # eject the DVD disk since we are finished with it
1532     [ $eject_disk -eq 2 ] && eject -T $dev
1533
1534     # encode the VOB file to a compressed file format
1535     if [ $make_final_dest_comp -eq 1 ]; then
1536       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1537
1538       # determine what our bitrate needs to be if a target size was specified instead
1539       calculate_bitrate_from_target_size        
1540      
1541       # encode the vob file into a compressed file format
1542       if [[ "$encoder" == "mencoder" ]]; then 
1543         encode_vob_file_mencoder
1544       fi
1545       if [[ "$encoder" == "handbrake" ]]; then
1546         encode_vob_file_handbrake
1547       fi
1548
1549       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1550         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1551         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1552       else
1553         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1554         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1555       fi
1556     fi
1557
1558   # add this video data to the mythtv DB
1559   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1560   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1561     
1562   else
1563
1564   # use dvdbackup to make a DVD folder of the feature title
1565   make_dvdbackup_folder_image
1566
1567   # cd to the feature title DVD folder
1568   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1569   if [ $? != 0 ]; then
1570     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1571   fi
1572   
1573   # create the dvd.xml file for dvdauthor
1574   create_dvdauthor_dvd_xml_file  
1575
1576   # make the final DVD folder image
1577   make_dvdauthor_folder_image
1578
1579   # add this video data to the mythtv DB
1580   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1581  
1582   # cd back to the dir we started from
1583   popd > /dev/null 2>&1
1584
1585   if [ $make_final_dest_iso -eq 1 ]; then
1586
1587     # make an iso image out of our directory
1588     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1589    
1590     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1591     if [ -s "$dest/$dvdname.iso" ]; then
1592       if [ $make_final_dest_folder -eq 0 ]; then
1593         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1594         # remove the folder of the DVD image now that we have a .iso version of it
1595         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1596       fi
1597     else
1598       # we created an empty iso file, remove it
1599       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1600       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1601       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1602     fi
1603  
1604     # add this video data to the mythtv DB
1605     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1606
1607   fi
1608
1609   fi
1610
1611   # remove the ddrescue DVD ISO image
1612   remove_intermediate_iso_file
1613
1614   # remove the tmp dvdbackup folder of the DVD image
1615   remove_intermediate_dvdbackup_folder
1616
1617   # eject the DVD disk upon completion
1618   [ $eject_disk -eq 1 ] && eject -T $dev
1619
1620   date=`date`
1621   echo "$date DVD rip completed" | tee -a "$logfile"
1622
1623   if [[ -n "$mailto" ]]; then
1624     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1625   fi
1626
1627 fi
1628
1629 ##############################################################################################